#include <stdlib.h>
#include <time.h>
#include "classes.h"
#include <iostream>

using namespace std;

void LIDL::info() {
  int x,y;
  cout << "Welcome to lidl v0.2.0, a wumpus clone\nBy Patrik Nilsson & Oskar Andreasson\n\n";
  for (x=0;x<=maxx;x=x+1)
    {
      for ( y=0; y<=maxy; y=y+1)
	{
	  room[x][y] = EMPTY;
	}
    }
  
#ifdef DEBUG
  for ( x=0; x<=maxx; x=x+1 ) {
    for (y=0; y<=maxy; y=y+1) {
      cout << "room[" << x << "][" << y << "] = " << room[x][y] << endl;
    }
    cout << endl;
  }
#endif

  /* place the monster */
  srand(time(NULL));
  x = rand() % maxx;
  y = rand() % maxy;
  room[x][y] = MONSTER;//The monster lidl

#ifdef DEBUG
  cout << "Monster placed in room[" << x << "][" << y << "] = " << room[x][y] << endl;
#endif
  
	
#ifdef DEBUG
  for ( x=0; x <= maxx; x=x+1 ) {
      for ( y=0; y<=maxy; y=y+1 ) {
	cout << "room[" << x << "][" << y << "] = " << room[x][y] << endl;
      }
      cout << endl;
  }
#endif

//holes
  
  int stopit=0;
  while( stopit != 3 ) {
  x = rand() % maxx;
  y = rand() % maxy;

    if ( room[x][y] == 0 ) {
      room[x][y]=TRAP;

#ifdef DEBUG
      cout << "Hole placed in room[" << x << "][" << y << "] = " << room[x][y] << endl;
#endif

      stopit++;
    }  
  }
  shots=5;
  
#ifdef DEBUG
  for ( x=0; x<=maxx; x=x+1 ) {
    for ( y=0; y<=maxy; y=y+1 ) {
      cout << "room[" << x << "][" << y << "] = " << room[x][y] << endl;
    }
    cout << endl;
  }
#endif
  
  //Bats
  stopit=0;
  while( stopit!=3 ) {
    x = rand() % maxx;
    y = rand() % maxy;
    
    if ( room[x][y] == 0 ) {
      room[x][y]=BAT;

#ifdef DEBUG
      cout << "Bat placed in room[" << x << "][" << y << "] = " << room[x][y] << endl;
#endif

      stopit++;
    }  
  }
  
  //Start poss
  stopit=0;
  while (!stopit >= 1) {
    x = rand() % maxx;
    y = rand() % maxy;
    
    if (room[x][y]==0) {
      wherex=x;
      wherey=y;
      stopit++;
    }
  }
	
#ifdef DEBUG
  cout << "Start location room[" << wherex << "][" << wherey << "].\n";
  for (x=0; x<=maxx; x=x+1) {
    for (y=0; y<=maxy; y=y+1) {
      cout << "room[" << x << "][" << y << "] = " << room[x][y] << endl;
    }
    cout << endl;
  }
#endif
}

LIDL::LIDL() {
#ifdef DEBUG
  cout << "LIDL::LIDL the lidl constructor\n";
#endif
  points=0;
  done=0;
  maxx=9;
  maxy=9;
}

void LIDL::ending() {
#ifdef DEBUG
  cout << "Entering ending()\n";
#endif
  // This ending is only shown when the user die's or win's not leaves
  if (done==TRUE) {
    cout << "Your score: " << points << endl;
  }
}
