#include <stdlib.h>
#include <time.h>
#include "classes.h"
#include <iostream>

using namespace std;

/*
 * Killed function checks to see if we where killed by any monsters/bad stuff.
 */

int LIDL::killed() {
#ifdef DEBUG
  cout << "Entering killed.\n";
#endif
  switch(room[wherex][wherey]) {
     case MONSTER: { 
       cout << ("You where killed by LIDL.\n");
       done=1;
       return TRUE;
       break;
     };
       
     case TRAP: {
       int type=rand() % 4; //1+(int) (4.0*rand()/(RAND_MAX+1.0));
       switch (type) {
         case 1: {
	    cout << "You fell into a trapdoor and died of starvation.\n";
	    break; 
	  };
	    
         case 2: {
	   cout << "A nasty part of the celling decided to end your life and did soo..\n";
	   break;
	 };

         case 3: {
	   cout << "Oh how nice a trapdoor, well i think you can figure out the rest.\n";
	   break;
	 };

         case 4: {
	   cout << "You hear a wining sound coming closer and closer, well it's an large iron bar under high velocity and you are in its path.\n";
	   break;
	 };
       }
       done=1;
       return TRUE;
       break;
     };

     case BAT: {
       cout << "One of your arrows was eaten alive by fruit eating bats.\nAnd the little pest flew away.\n";
       room[wherex][wherey]= EMPTY;
       shots--;
       break;
     };

     case EMPTY: {
       cout << "The room is empty.\n";
       break;
     };
       
     default: {
       cout << "Aiee, the room has a weird value " << room[wherex][wherey] << endl;
       break;
     };
  }
#ifdef DEBUG
  cout << "Room content: " << room[wherex][wherey] << endl;
#endif
	return FALSE;
}

/*
 * Surrounding checks all rooms around the room we just moved into and prints a warning
 * for each room around us that contains something bad.
 */

int LIDL::surroundings() {
  if (done != 1) {
    int x,y;
#ifdef DEBUG
    cout << "Entering surroundings.\n";
#endif
    for (x = -1; x <= 1; x = x+1) {
      if (x>=0 && x<=maxx)
#ifdef DEBUG
	cout << "Entering x loop.\n";
#endif
      for (y = -1; y <= 1; y = y+1) {
#ifdef DEBUG
	cout << "Checking room[" << wherex+x << "][" << wherey+y << "] = " << room[wherex+x][wherey+y] << endl;
#endif
	if (room[wherex+x][wherey+y] != EMPTY && wherex+x<=maxx && wherex+x>0 && wherey+y<=maxy && wherey+y>0) {
	  if (room[wherex+x][wherey+y] == MONSTER) {
	    cout << "You feel a gust of wind carrying the smell of rotting meat.\n The monster is near.\n";
	  }		  
	  else if (room[wherex+x][wherey+y] == TRAP) {
	    cout << "You get a bad fealing about this." << endl; //printf("You feel the smell of plastic roses. The plant department is close.\n"); // We do not want people to know that they might die!
	  }		  
	  else if (room[wherex+x][wherey+y] == BAT) {		    
	    cout << "The sweet smell of fruit warns you. The fruit eating bats are close." << endl;
	  }
	  else {
	    cout << "Aiee, bad value in room " << wherex+x << "," << wherey+y << " value: " << room[wherex+x][wherey+y] << endl;
	  }
	}
      }
    }
  }
}
